/* Copyright (C) 1999 Dustin Ward <Vortex@qconline.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */
#include "commands.h"
COMMAND commands[] = {
/*  Name    Function        Documentation         Type 0=CD 1=Misc. */
  {"list", com_list, "lists all available tracks", 0},
  {"play", com_play, "play [track/trackname] [endtrack] || first --> last track", 0},
  {"help", com_help, "displays a help message", 0},
  {"next", com_next, "plays next track", 0},
  {"prev", com_prev, "plays previous track", 0},
  {"stop", com_stop, "stops the cd from playing", 0},
  {"pause", com_pause, "pauses cd", 0},
  {"resume", com_resume, "resumes cd after pausing", 0},
  {"dcache", com_delcache, "<arg> if arg == 0, will remove present entry else it removes all your cddb cache", 1},
  {"eject", com_eject, "open's the cdtray", 0},
  {"close", com_close, "closes the cdtray", 0},
  {"status", com_status, "shows current status of the cd", 0},
  {"clear", com_clear, "clear's the screen", 1},
  {"reset", com_reset, "restarts program", 1},
  {"quit", com_quit, "exits program", 1},
  {"vol", com_setvol, "gets/sets current volume value", 1},
   {"info", com_info,
   "gives extra information about cd, track names, titles, etc", 1},
  {"ff", com_ff, "[secs] advances cd", 0},
  {"rew", com_rew, "[secs] rewinds cd", 0},
  {"edit", com_edit, "allows you to edit cddb info", 1},
  {"submit", com_submit, "allows you to submit your entry",1},
  
  {"type", com_type,
   "Allows you to set the type of connection for CDDB/CDindex", 1},
  {"access", com_acc,
   "Allows you to set the access to the connection, local, or remote",1},
  {"save", com_sav, "Saves current settings to rc file",1},
  {"random", com_rand, "Plays a random track",0},
#ifdef MODSUPPORT
  {"insmod", com_insmod, "<module>, loads module", 1},
  {"rmmod", com_rmmod, "<module>, remove module",1},
  {"lsmod", com_lsmod, "lists currently loaded modules",1},
#endif
  {"rcvals", prntrc, "prints config file values",1},
  {"version", Ver, "prints version",1},
  {"chdisc", com_chan, "<disc>, cd changer",0},
  {"mode", com_mode, "change cdrom mode, loop/shuffle/normal",0},
  {"sframe", com_savep, "Save frame to file for future resume", 1},
  {"rframe", com_resp, "Resume saved frame", 1},
  {"set", com_set, "Change device / server, ie: set device /dev/cdrom", 1},
  {(char *) NULL, (Function *) NULL, (char *) NULL, (int) NULL}
};
PidList pids;
DCD DcD;

int addserver(char *val, DCD *dcd)
{
   if(DcD.num > 100) DcD.num=0;
   strcpy(DcD.serv[DcD.num].server, val);
   DcD.num++;
   return 0;
}
int com_set (DCD *dcd)
{
   int x=0;
   if ((!strcasecmp(dcd->arg, "device")) || (!strcasecmp(dcd->arg, "dev")))
     {
	if(*dcd->param)
	  {
	     chdev(dcd->param, dcd->fd);
	  }
	else
	  {
	     printf("device? \n");
	  }
     }
   else if (!strcasecmp(dcd->arg, "server"))
     {
	if(*dcd->param)
	  {
	     strcpy(CDDB_DEFAULT_HOSTNAME, dcd->param);
	     strcpy(DcD.serv[DcD.num].server, CDDB_DEFAULT_HOSTNAME);
	     writetocddb (DEFAULTTYPE, CDDB_DEFAULT_HOSTNAME, DEFAULTACCESS);
	     printf("%d\n", DcD.num);
	     strcpy(DcD.serv[DcD.num].server, CDDB_DEFAULT_HOSTNAME);
	     DcD.num++;
	  }
	else
	  {
	     printf("--Server List--\n");
	     for(x=0;x<DcD.num;x++)
	       {
	     printf("# %d - %s\n", x, DcD.serv[x].server);
	       }
	     printf("Number-> ");
	     scanf("%d", &y);
       	     if(y<0)
	       {
		  printf("Invalid Server\n");
		  return -1;
	       }
	     if(y>DcD.num)
	       {
		  printf("Invalid Server\n");
		  return -1;
	       }
	     printf("Setting server to %s\n", DcD.serv[y].server);
	     strcpy(CDDB_DEFAULT_HOSTNAME, DcD.serv[y].server);
	     writetocddb (DEFAULTTYPE, CDDB_DEFAULT_HOSTNAME, DEFAULTACCESS);
             return 0;
	  }
     }
   else if (!*dcd->arg)
     {
	printf("Need arg, must be either device or server\n");
        return 0;
     }
   else
     {
	printf("Arg must be either device or server\n");
        return 0;
     }
   return 0;
}
	     
int com_savep(DCD *dcd)
{
   FILE *poss;
   int pos2;
   int pos3;
   int track;
   
   sprintf(filename, "%s/.demcd/.demcdfr", getenv("HOME"));
   poss=fopen(filename, "w");
   cd_stat(dcd->fd, &disc);
   track=disc.disc_current_track-1;
   pos2=disc.disc_track[track].track_pos.minutes *4500 + disc.disc_track[track].track_pos.seconds *75 + disc.disc_track[track].track_pos.frames;
   pos3=disc.disc_track_time.minutes *4500 + disc.disc_track_time.seconds *75 + disc.disc_track_time.frames;
   printf("Saving frame %d\n", pos2+pos3);
   fprintf(poss, "%02lx ", cddb_discid (dcd->fd));
   fprintf(poss, "%d",pos2+pos3);
   fclose(poss);
   return 0;
}
int com_resp(DCD *dcd)
{
   FILE *pos;
   char blah[100];
   char blah2[100];
   char *opt;
   char *val;
   int pos1;
   int endpos;
   
   opt=malloc(100);
   val=malloc(100);
   sprintf(filename, "%s/.demcd/.demcdfr", getenv("HOME"));
   if((pos=fopen(filename, "r")) == NULL)
     {
	printf("Forget to save frame?\n");
	return 0;
     }
   fgets(blah, 99, pos);
   opt = strtok (blah, "     \r\n");
   val = strtok (NULL, "\r\n");
   sprintf(blah2, "%02lx", cddb_discid (dcd->fd));
   pos1=atoi(val);
   
   if(!strcmp(blah2, opt))
     {
   cd_stat(dcd->fd, &disc);
   endpos=disc.disc_track[disc.disc_total_tracks].track_pos.minutes *4500 + disc.disc_track[disc.disc_total_tracks].track_pos.seconds *75 + disc.disc_track[disc.disc_total_tracks].track_pos.frames;
   printf("Resuming at frame %d\n", pos1);
   cd_play_frames(dcd->fd, pos1, endpos);
     }
   else
     {
	printf("Error: CD ID's don't match\n");
     }
	return 0;
}
int com_shuf(DCD *dcd)
{
    int Q=0;
    char Buff[100];
    FILE *RAND;
    
    sprintf(filename, "%s/.demcd/.demcdrand", getenv("HOME"));
   if((RAND=fopen(filename, "r")) == NULL)
     {
	Q=1;
     }
   if(Q!=1)
     {
   fgets(Buff, 100, RAND);
      if(!strcasecmp(Buff, "on"))
     {
	fclose(RAND);
     	printf("Already shuffling\n");
	return 0;
     }
     fclose(RAND);
     }
      pid=fork();
      switch(pid)
     {
      case -1:
	perror("unable to fork");
	break;
      case 0:
	break;
      case 1:
	wait (&waitstatus);
	_exit (EXIT_SUCCESS);
	break;
     }
    pids.pid=getpid();
   RAND=fopen(filename, "w");
   fprintf(RAND, "on");
   fclose(RAND);
   while(pid)
     {
	RAND=fopen(filename, "r");
	fgets(Buff, 100, RAND);
	if(!strcasecmp(Buff, "off"))
	  {
	  fclose(RAND);
	  return 0;
	  }
	else{
	  fclose(RAND);
	}
	cd_stat (dcd->fd, &disc);
	if(disc.disc_current_track != track)
	  {
	     com_rand(dcd);
	     cd_stat (dcd->fd, &disc);
	     track=disc.disc_current_track;
	     cd_stat (dcd->fd, &disc);
	     sleep(1);
	  }
     }
return 0;
}

int com_mode(DCD *dcd)
{
   FILE *test;
   char *buff;
   int o;
   int btrack;
   int etrack;
   int z=0;
   int mode=1;
   int p=0;
   
   buff=malloc(15);
   sprintf(filename, "%s/.demcd/.demcdloop", getenv("HOME"));
   if((test=fopen(filename, "r")) == NULL)
   z=1;
   if(z!=1)
     {
	fgets(buff, 15, test);
	if(!strcasecmp(buff, "off"))
	  z=1;
	else 
           mode=2;
	
	fclose(test);
     }
     sprintf(filename, "%s/.demcd/.demcdrand", getenv("HOME"));
    if((test=fopen(filename, "r")) == NULL)
	  {
	       p=1;
      	       mode=1;
	  }

     else if (p!=1)
     {
	   fgets(buff, 15, test);
	   if(!strcasecmp(buff, "on"))
	     {
	     mode=3;
	     }
     }
     else if(z==1)
     {
     mode=1;
     }
  	   else {
	     mode=2;
	   }
     switch(mode)
     {
      case 1:
	printf("Current mode: Normal\n");
	break;
      case 2:
	printf("Current mode: Looping\n");
	break;
      case 3:
	printf("Current mode: Shuffling\n");
	break;
     }
     printf("Modes\n");
     printf("----------\n");
     printf("1. Normal\n");
     printf("2. Loop\n");
     printf("3. Shuffle\n\n");
     printf("Mode #?: ");
     scanf("%d", &o);
     switch(o)
     {
      case 1:
	com_loopf(dcd);
	break;
      case 2:
	if(mode==3)
	  {
	  printf("Shutting off Shuffling, try again\n");
	  com_loopf(dcd);
	  }
	printf("begin track(0 for whole cd): ");
	scanf("%d", &btrack);
	if(btrack>0)
	  {
	     printf("end track: ");
	     scanf("%d", &etrack);
	     sprintf(dcd->arg, "%d", btrack);
	     sprintf(dcd->param, "%d", etrack);
	  }
	com_loop(dcd);
        break;
      case 3:
	if(mode==2)
	  {
	  printf("Shutting off loop, try again\n");
	  com_loopf(dcd);
   	  usleep(1000);
	  }
	com_shuf(dcd);
	break;
     }
   return 0;
}
	
int com_loop(DCD *dcd)
{
    int ttrack=0;
    int etrack=0;
    int Q=0;
    char Buff[100];
    FILE *LOOP;
    
   if(atoi(dcd->arg))
     {
      	printf("Looping Track %d", atoi(dcd->arg));
	ttrack=atoi(dcd->arg);
     }
   if(atoi(dcd->param))
       {
	  etrack=atoi(dcd->param);
	  printf(" --> %d", etrack);
       }
   printf("\n");
   sprintf(filename, "%s/.demcd/.demcdloop", getenv("HOME"));
   if((LOOP=fopen(filename, "r")) == NULL)
     {
	Q=1;
     }
   if(Q!=1)
     {
   fgets(Buff, 100, LOOP);
      if(!strcasecmp(Buff, "on"))
     {
	fclose(LOOP);
     	printf("Already Looping\n");
	return 0;
     }
     fclose(LOOP);
     }
      pid=fork();
      switch(pid)
     {
      case -1:
	perror("unable to fork");
	break;
      case 0:
	break;
      case 1:
	wait (&waitstatus);
	_exit (EXIT_SUCCESS);
	break;
     }
    pids.pid=getpid();
   LOOP=fopen(filename, "w");
   fprintf(LOOP, "on");
   fclose(LOOP);
   sprintf(filename, "%s/.demcd/.demcdloop", getenv("HOME"));
   while(pid)
     {
	LOOP=fopen(filename, "r");
	fgets(Buff, 100, LOOP);
	if(!strcasecmp(Buff, "off"))
	  {
	  fclose(LOOP);
	  return 0;
	  }
	else{
	  fclose(LOOP);
	}
	cd_stat (dcd->fd, &disc);
	if(ttrack==0)
	  {
	switch(disc.disc_mode)
	  {
	   case CDAUDIO_COMPLETED:
	   case CDAUDIO_NOSTATUS:
	     demcd_play_track(dcd->fd, 1, disc.disc_total_tracks);
	     break;
	  }
	  }
	else
	  {
	     if(etrack == 0)
	       etrack=ttrack;
	     if((disc.disc_current_track < ttrack) || (disc.disc_current_track > etrack))
	       {
	      		 demcd_play_track(dcd->fd, ttrack, etrack);
	       }
	             switch(disc.disc_mode)
	       {
		case CDAUDIO_COMPLETED:
		case CDAUDIO_NOSTATUS:
		         demcd_play_track(dcd->fd, ttrack, etrack);
		               break;
	       }
	     
	  }
     }
return 0;
}
int demcd_play_track(int fd, int start, int end)
{
   cd_stat(fd, &disc);
   if(disc.disc_track[start - 1].track_type == CDAUDIO_TRACK_DATA)
     {
	printf("Unable to play data tracks\n");
	return -1;
     }
   cd_play_track(fd, start, end);
   return 0;
}
int com_loopf(DCD *dcd)
{
   FILE *LOOP;
   FILE *RAND;
   
   sprintf(filename, "%s/.demcd/.demcdloop", getenv("HOME"));
   LOOP=fopen(filename, "w");
   fprintf(LOOP, "off");
   fclose(LOOP);
   sprintf(filename, "%s/.demcd/.demcdrand", getenv("HOME"));
   RAND=fopen(filename, "w");
   fprintf(RAND, "off");
   fclose(RAND);
   usleep(1000);
   if(pids.pid > 1)
   kill(pids.pid, SIGQUIT);
   return 0;
}
int com_chan(DCD *dcd)
{
    cd_changer_stat(dcd->fd, &changer);
   if (!*dcd->arg)
     {
	printf("Slots: %d\n", changer.changer_slots);
	return 0;
     }
   cd_changer_select_disc(dcd->fd, atoi(dcd->arg));
return 0;
}
   
   
   
int fixlist ()
{
  register int i;
  for (i = 0; commands[i].func; i++)
    {
      // Do nothing
    }
  i--;
  commands[i].name = (char *) NULL;
  commands[i].func = (Function *) NULL;
  commands[i].doc = (char *) NULL;
  commands[i].type = (int) NULL;
  return 0;
}
#ifdef MODSUPPORT
int
addhook (char *name, Function *func, char *doc)
{
  int i;
  for (i = 0; commands[i].func; i++)
    {
      if (!strcmp (name, commands[i].name))
	{
	  printf ("Error: addhook(): already a command named %s\n", name);
	  return 0;
	}
    }
  commands[i].name = name;
  commands[i].func = func;
  commands[i].doc = doc;
  commands[i].type = 1;
  i++;
  commands[i].name = (char *) NULL;
  commands[i].func = (Function *) NULL;
  commands[i].doc = (char *) NULL;
  commands[i].type = 1;
  return 0;
}
#endif
int
com_sav ()
{
  FILE *fptr;
  char PATH[100];
  strcpy (PATH, getenv ("HOME"));
  strcat (PATH, "/.demcdrc");
  fptr = fopen (PATH, "w");
  process_new (fptr, 1);
  for(y=0;y<DcD.num;y++)
  fprintf (fptr, "cddbserver %s\n", DcD.serv[y].server);
  fprintf (fptr, "default-device %s\n", CD_DEV);
  fprintf (fptr, "access %s\n", DEFAULTACCESS);
  fprintf (fptr, "type %d\n", DEFAULTTYPE);
  switch(LOCKED)
     {
      case 0:
	fprintf (fptr, "lock on\n");
	break;
      default:
	fprintf (fptr, "lock off\n");
	break;
     }
  fclose (fptr);
  printf ("Saved\n");
  return 0;
}

int Ver()
{
   char buff[256];
   printf("demcd %s\n", VER);
   printf("Author: Dustin Ward, AKA: dem\n");
   printf("Released: %s\n", RELEASED);
   cd_version(buff, 256);
   printf("Using %s\n", buff);
   return 0;
}
int
com_acc (DCD *dcd)
{
  int x;
  printf ("ACCESS TYPES\n");
  printf ("------------\n");
  printf ("0:\tremote\n");
  printf ("1:\tlocal\n");
  printf ("\nAccess#: ");
  scanf ("%d", &x);
  switch (x)
    {
    case 0:
      strcpy (DEFAULTACCESS, "REMOTE");
      break;
    case 1:
      strcpy (DEFAULTACCESS, "LOCAL");
      break;
    default:
      printf ("No such access #\n");
      break;
    }
  writetocddb (DEFAULTTYPE, CDDB_DEFAULT_HOSTNAME, DEFAULTACCESS);
  return 0;
}

int
com_type (DCD *dcd)
{
  int x;

  /*
   *  * CDDB_MODE_CDDBP        0
   *  * CDDB_MODE_HTTP         1
   *  */
  printf ("  CDDB/CDINDEX TYPES\n");
  printf ("----------------------\n");
  printf ("0:\tcddbp\n");
  printf ("1:\thttp\n");
  printf ("\nType#: ");
  scanf ("%d", &x);
       switch (x)
	{
	case (CDDB_MODE_CDDBP):
	  writetocddb (x, CDDB_DEFAULT_HOSTNAME, DEFAULTACCESS);
	  break;
	case (CDDB_MODE_HTTP):
	  writetocddb (x, CDDB_DEFAULT_HOSTNAME, DEFAULTACCESS);
	  break;
	default:
	  printf ("No such type\n");
	  return 0;
	  break;

	}
      DEFAULTTYPE = x;
 return 0;
}
int
com_play (DCD *dcd)
     
     
{
  int z;
  cd_stat (dcd->fd, &disc);
  endtrack = disc.disc_total_tracks;
  x = disc.disc_current_track;
  y = endtrack;
    if (atoi(dcd->arg)>0)
    {
      track = strtol (dcd->arg, NULL, 10);
    }
  if(*dcd->arg)
     {
     for(z=0;z<disc.disc_total_tracks;z++)
     {
     if(!strcasecmp(dcd->whole, data.data_track[z].track_name)) // Found IT!
	  {
	     track=z;
	     track++;
	  }
      else if(!strncasecmp(dcd->whole, data.data_track[z].track_name, 5)) // Lets try again
	  {
	     track=z;
	     track++;
	  }
     }
     }
   if ((atoi(dcd->param))>0)
     {
	endtrack=strtol (dcd->param, NULL, 10);
     }
   if (track == 0)
    track = 1;
   if(track > endtrack)
     track=1;
  printf ("Playing Tracks %d --> %d\n", track, endtrack);
  demcd_play_track (dcd->fd, track, endtrack);
return 0;
}
#ifdef MODSUPPORT
int
com_insmod (DCD *dcd)
     
     
{
  if (!*dcd->arg)
    {
      printf ("Module name?, (omit the .so)\n");
      return 0;
    }
  insmod (dcd->arg);
return 0;
}
#endif
int
com_rand (DCD *dcd)
     
     
{
  int track;
  srandom (time (NULL));
  cd_stat (dcd->fd, &disc);
  endtrack = disc.disc_total_tracks;
  track = (random () % endtrack) + 1;
  printf ("Playing track %d\n", track);
  demcd_play_track (dcd->fd, track, track);
return 0;
}
int
com_clear ()
{
  system ("clear");
return 0;
}
int
com_getvol (DCD *dcd)
     
     
{
  cd_get_volume (dcd->fd, &vol);
  vol.vol_front.left = (vol.vol_front.left * 100) / 255;
  vol.vol_front.right = (vol.vol_front.right * 100) / 255;
  vol.vol_back.left = (vol.vol_back.left * 100) / 255;
  vol.vol_back.right = (vol.vol_back.right * 100) / 255;
  printf ("Left: %d%%\tRight: %d%%\n", vol.vol_front.left,
	  vol.vol_front.right);
return 0;
}

int
com_setvol (DCD *dcd)
     
     
{
  float blah, blah1;
  int g = 0;
  if (!*dcd->arg)
    {
       com_getvol(dcd);
       return 0;
    }

  if (dcd->arg)
    {
      blah = atoi (dcd->arg);
      g = 1;
      if (blah < 100)
	{
	  blah = blah + 1;
	}
      blah1 = (blah / 100) * 255;
      vol.vol_front.left = blah1;
      vol.vol_front.right = blah1;
      vol.vol_back.left = blah1;
      vol.vol_back.right = blah1;
      if (cd_set_volume (dcd->fd, vol) < 0)
	{
	  printf ("Invalid volume\n");
	  printf ("See: help setvol\n");
	}
    }
return 0;
}
int
com_reset (DCD *dcd)
{
  printf ("Resetting.......\n");
  close (dcd->fd);
  main (dcd->argc, dcd->argv);
return 0;
}
int
com_next (DCD *dcd)
     
     
{
   cd_stat (dcd->fd, &disc);
  if(!*dcd->arg)
     track = disc.disc_current_track + 1;
  else
     track = disc.disc_current_track + atoi(dcd->arg);
   endtrack = disc.disc_total_tracks;
   if(track > endtrack)
          track=1;
  printf ("Playing Tracks %d --> %d\n", track, disc.disc_total_tracks);
  demcd_play_track (dcd->fd, track, disc.disc_total_tracks);
return 0;
}

int
com_prev (DCD *dcd)
     
     
{
  cd_stat (dcd->fd, &disc);
  endtrack = disc.disc_total_tracks;
   if(!*dcd->arg)
     track = disc.disc_current_track - 1;
   else
     track = disc.disc_current_track - atoi(dcd->arg);
     if(track > endtrack)
          track=endtrack;
  printf ("Playing Tracks %d --> %d\n", track, disc.disc_total_tracks);
  demcd_play_track (dcd->fd, track, disc.disc_total_tracks);
return 0;
}
int
com_stop (DCD *dcd)
     
     
{
  cd_stop (dcd->fd);
return 0;
}
int
com_pause (DCD *dcd)
     
     
{
  cd_pause (dcd->fd);
return 0;
}
int
com_resume (DCD *dcd)
     
     
{
  cd_resume (dcd->fd);
return 0;
}
int
com_eject (DCD *dcd)
     
     
{
  cd_stop (dcd->fd);
  cd_eject (dcd->fd);
return 0;
}
int
com_close (DCD *dcd)
     
     
{
  cd_close (dcd->fd);
return 0;
}
int
com_quit (DCD *dcd)
     
     
{
  sprintf(filename, "%s/.demcd/.demcdloop", getenv("HOME"));
  com_loopf(dcd);
  system("rm ~/.demcd/.demcdloop &>/dev/null");
  close (dcd->fd);
  kill(0, SIGQUIT);
  return 0;
}
int
com_info (DCD *dcd)
     
     
{

  int a = 0;
  int p, d, z = 0;
  int o;
  char file[256], root_dir[256];
  struct stat st;
  snprintf (root_dir, 256, "%s/.cddb", getenv ("HOME"));

  for (p = 0; p < 12; p++)
    {
      snprintf (file, 256, "%s/%s/%08lx", root_dir, cddb_genre (p),
		cddb_discid (dcd->fd));
      d = stat (file, &st);
      if (d == 0)
	z = 1;
    }

  data.data_id = cddb_discid (dcd->fd);
  if (z != 1)
    {
      fprintf (output, "Resolving %s... ", CDDB_DEFAULT_HOSTNAME);
      if ((he = gethostbyname (CDDB_DEFAULT_HOSTNAME)) == NULL)
	{
	  printf ("Unable to resolve %s\n", CDDB_DEFAULT_HOSTNAME);
	  printf ("Try anyway [yn]? ");
	  fgets (buff, 100, stdin);
	  buff[strlen (buff) - 1] = '\0';
	  if (!strcasecmp (buff, "y"))
	    {
	      a = 1;
	    }
	  else
	    {
	      return 0;
	    }
	}
      if (a != 1)
	fprintf (output, "(%s)\n",
		 inet_ntoa (*((struct in_addr *) he->h_addr)));
      fprintf (output, "Getting CDDB info for CD(%02lx) from %s\n\n",
	       data.data_id, CDDB_DEFAULT_HOSTNAME);
    }
  cd_stat (dcd->fd, &disc);
  o=disc.disc_current_track;
  data.data_id = cddb_discid (dcd->fd);
  if (cddb_read_disc_data (dcd->fd, &data) < 0)
    {
      printf ("Error: cddb_read_disc_data();\n");
      return -1;
    }
   if (cddb_write_disc_data(dcd->fd, data) < 0)
     {
	printf("Error: cddb_write_disc_data();\n");
	return -1;
     }
  printf ("Album name:   \t%s\n", data.data_title);
  printf ("Album artist: \t%s\n", data.data_artist);
  printf ("Album genre:  \t%s\n", cddb_genre (data.data_genre));
  printf ("Total tracks: \t%d\tDisc length:\t%02d:%02d\n\n",
	  disc.disc_total_tracks, disc.disc_length.minutes,
	  disc.disc_length.seconds);
  printf ("Track           Name\n");
  printf ("-----------------------------------\n");
  y = disc.disc_total_tracks;
   for (x = 0; x < y; x++)
    {
       disc.disc_current_track = x + 1;
       if(disc.disc_track[disc.disc_current_track - 1].track_type == CDAUDIO_TRACK_DATA)
	 strcat(data.data_track[x].track_name, "(DATA TRACK)");
       
       if(o==disc.disc_current_track)
	 {
          if (strlen (data.data_track[x].track_artist) > 0)
	printf ("[47m[30mTrack %d:\t%s -- %s[0m\n", disc.disc_current_track,
		data.data_track[x].track_name,
		data.data_track[x].track_artist);
      else
	printf ("[47m[30mTrack %d:\t%s[0m\n", disc.disc_current_track,
		data.data_track[x].track_name);
	 }
       else 
	 {
	          if (strlen (data.data_track[x].track_artist) > 0)
	printf ("Track %d:\t%s -- %s\n", disc.disc_current_track,
		data.data_track[x].track_name,
		data.data_track[x].track_artist);
      else
	printf ("Track %d:\t%s\n", disc.disc_current_track,
		data.data_track[x].track_name);
	 }
    
    }
  return 0;
}

int
com_rew (DCD *dcd)
     
     
{
  if (*dcd->arg)
    {
      disc_time.seconds =- (strtol (dcd->arg, NULL, 10));
    }
  else
    {
      disc_time.seconds =- 15;
    }
  disc_time.minutes = 0;
  printf ("Rewinding %d secs\n", disc_time.seconds);
  cd_advance (dcd->fd, disc_time);
return 0;
}
int
com_ff (DCD *dcd)
     
     
{
  if (*dcd->arg)
    {
      disc_time.seconds = strtol (dcd->arg, NULL, 10);
    }
  else
    {
      disc_time.seconds = 15;
    }
  disc_time.minutes = 0;
  printf ("Fowarding %d secs\n", disc_time.seconds);
  cd_advance (dcd->fd, disc_time);
return 0;
}
int
com_list (DCD *dcd)
     
     
{
  int q;
  cd_stat (dcd->fd, &disc);
  q=disc.disc_current_track;
  printf ("Track           Length\n");
  printf ("------------------------\n");
  for (x = 0; x < disc.disc_total_tracks; x++)
    {
      disc.disc_current_track = x + 1;
       if(disc.disc_current_track==q)
	 printf ("[47m[30mTrack: %d \t[%02d:%02d][0m\n", disc.disc_current_track,
	      disc.disc_track[disc.disc_current_track -
			      1].track_length.minutes,
	      disc.disc_track[disc.disc_current_track -
			      1].track_length.seconds);
       else
	 
         printf ("Track: %d \t[%02d:%02d]\n", disc.disc_current_track,
	      disc.disc_track[disc.disc_current_track -
			      1].track_length.minutes,
	      disc.disc_track[disc.disc_current_track -
			      1].track_length.seconds);
    }
  disc.disc_current_track = 0;
  printf ("-------------------------\n");
  printf ("Total time \t[%02d:%02d]\n",
	  disc.disc_track[disc.disc_current_track - 1].track_length.minutes,
	  disc.disc_track[disc.disc_current_track - 1].track_length.seconds);
return 0;
}
int
com_status (DCD *dcd)
     
     
{
  int blah4;
  cd_stat (dcd->fd, &disc);
  if (cddb_read_disc_data (dcd->fd, &data) < 0)
    {
      printf ("Error: cddb_read_disc_data();\n");
      return -1;
    }
  blah1 = disc.disc_track_time.minutes * 60 + disc.disc_track_time.seconds;
  blah2 =
    disc.disc_track[disc.disc_current_track - 1].track_length.minutes * 60 +
    disc.disc_track[disc.disc_current_track - 1].track_length.seconds;
  blah4=(blah1 / blah2) * 100;
   switch (disc.disc_mode)
    {
    case CDAUDIO_PLAYING:
      if (*data.data_track[disc.disc_current_track - 1].track_artist)
	sprintf (buff,
		 "\rPlaying track %d <%s> [%02d:%02d]/[%02d:%02d] [%.2f%%]/[100%%]\n",
		 disc.disc_current_track,
		 data.data_track[disc.disc_current_track - 1].track_artist,
		 disc.disc_track_time.minutes, disc.disc_track_time.seconds,
		 disc.disc_track[disc.disc_current_track -
				 1].track_length.minutes,
		 disc.disc_track[disc.disc_current_track -
				 1].track_length.seconds,
		 (blah1 / blah2) * 100);
      else if (*data.data_track[disc.disc_current_track -1].track_name)
	sprintf (buff,
		 "\rPlaying track %d <%s> [%02d:%02d]/[%02d:%02d] [%.2f%%]/[100%%]\n",
		 disc.disc_current_track,
		 data.data_track[disc.disc_current_track - 1].track_name,
		 disc.disc_track_time.minutes, disc.disc_track_time.seconds,
		 disc.disc_track[disc.disc_current_track -
				 1].track_length.minutes,
		 disc.disc_track[disc.disc_current_track -
				 1].track_length.seconds,
		 (blah1 / blah2) * 100);
      else
	sprintf (buff,
		 "\rPlaying track %d [%02d:%02d]/[%02d:%02d] [%.2f%%]/[100%%]\n",
		 disc.disc_current_track, disc.disc_track_time.minutes,
		 disc.disc_track_time.seconds,
		 disc.disc_track[disc.disc_current_track -
				 1].track_length.minutes,
		 disc.disc_track[disc.disc_current_track -
				 1].track_length.seconds,
		 (blah1 / blah2) * 100);
      fprintf (output, buff);
      statusbar(blah4);
      break;
    case CDAUDIO_PAUSED:
      if (*data.data_track[disc.disc_current_track-1].track_artist)
	sprintf (buff,
		 "\rPaused -- track %d <%s> [%02d:%02d]/[%02d:%02d] [%.2f%%]/[100%%]\n",
		 disc.disc_current_track,
		 data.data_track[disc.disc_current_track - 1].track_artist,
		 disc.disc_track_time.minutes, disc.disc_track_time.seconds,
		 disc.disc_track[disc.disc_current_track -
				 1].track_length.minutes,
		 disc.disc_track[disc.disc_current_track -
				 1].track_length.seconds,
		 (blah1 / blah2) * 100);
      else if (*data.data_track[disc.disc_current_track-1].track_name)
	sprintf (buff,
		 "\rPaused -- track %d <%s> [%02d:%02d]/[%02d:%02d] [%.2f%%]/[100%%]\n",
		 disc.disc_current_track,
		 data.data_track[disc.disc_current_track - 1].track_name,
		 disc.disc_track_time.minutes, disc.disc_track_time.seconds,
		 disc.disc_track[disc.disc_current_track -
				 1].track_length.minutes,
		 disc.disc_track[disc.disc_current_track -
				 1].track_length.seconds,
		 (blah1 / blah2) * 100);
      else
	sprintf (buff,
		 "\rPaused -- track %d [%02d:%02d]/[%02d:%02d] [%.2f%%]/[100%%]\n",
		 disc.disc_current_track, disc.disc_track_time.minutes,
		 disc.disc_track_time.seconds,
		 disc.disc_track[disc.disc_current_track -
				 1].track_length.minutes,
		 disc.disc_track[disc.disc_current_track -
				 1].track_length.seconds,
		 (blah1 / blah2) * 100);
      fprintf (output, buff);
      statusbar(blah4);
      break;
    case CDAUDIO_COMPLETED:
      printf ("Stopped\n");
      break;
    case CDAUDIO_NOSTATUS:
      printf ("Stopped\n");
    }
return 0;
}

int
com_help (DCD *dcd)
     
     
{
  register int i;
  int printed = 0;


  for (i = 0; commands[i].name; i++)
    {
      if (!*dcd->arg)
	{
	  printf ("CDPlayer Commands:\n");
	  printf ("------------------\n");

	  for (i = 0; commands[i].name; i++)
	    {
	      if(commands[i].type == 0)
	      printf ("%s\t", commands[i].name);
	      printed++;
	    }
	  printf("\nMisc. Commands:\n");
	  printf("---------------\n"); 
	  for (i = 0; commands[i].name; i++)
	    {
	      if(commands[i].type == 1)
	      printf ("%s\t", commands[i].name);
	      printed++;
	    }
	  printf ("\n\nhelp <command> for further help\n");
	  return 0;
	}
      else if (!*dcd->arg || (strcasecmp (dcd->arg, commands[i].name) == 0))
	{
	  printf ("%s: %s\n", commands[i].name, commands[i].doc);
	  printed++;
	}
    }

  if (!printed)
    {
      printf ("Error: No help for %s\n", dcd->arg);
    }

  return (0);
}

int
com_delcache (DCD *dcd)
{
  buff2 = malloc (512);
  if(*dcd->arg)
     {
	cddb_erase_entry (data);
	return 0;
     }
  getinput (buff2, "Are you sure you want to delete your cddb cache? [y/n] ");
  if (((strspn (buff2, "y")) != 0) || ((strspn (buff2, "Y")) != 0))
    {
      system ("rm -frv ~/.cddb");
    }
  else
    {
      printf ("Ok, Not removing\n");
    }
   free(buff2);
   return 0;
}
int
com_edit (DCD *dcd)
     
     
{
  while (1)
    {
      data.data_id = cddb_discid (dcd->fd);
      buff2 = malloc (512);
      getinput (buff2, "Edit what? (name, artist, genre, (track#), quit) ");
      if (strcasecmp (buff2, "quit") == 0)
	{
	  break;
	}
      else if (strcasecmp (buff2, "name") == 0)
	{
	  printf ("(Current Value: %s): Enter new Value: ", data.data_title);
	  fgets (data.data_title, 100, stdin);
	  data.data_title[strlen (data.data_title) - 1] = '\0';
	}
      else if (strcasecmp (buff2, "artist") == 0)
	{
	  printf ("(Current Value: %s): Enter new Value: ", data.data_artist);
	  fgets (data.data_artist, 100, stdin);
	  data.data_artist[strlen (data.data_artist) - 1] = '\0';
	}
      else if (strcasecmp (buff2, "genre") == 0)
	{
	  while (1)
	    {
	      printf ("(Current Value: %s): Enter new Value: ",
		      cddb_genre (data.data_genre));
	      fgets (buff, 512, stdin);
	      buff[strlen (buff) - 1] = '\0';
	      for (lindex = 1; lindex < 12; lindex++)
		if (strncasecmp (buff, cddb_genre (lindex), 4) == 0)
		  {
		    cddb_erase_entry (data);
		    data.data_genre = lindex;
		    cddb_write_disc_data (dcd->fd, data);
		    return 0;
		  }
	      puts ("Error: Valid genres are:");
	      for (lindex = 1; lindex < 12; lindex++)
		puts (cddb_genre (lindex));
	    }
	  continue;
	}
      else if ((track = strtol (buff2, NULL, 10)) != 0)
	{
	  printf ("(Current Value: %s): Enter new Value: ",
		  data.data_track[track - 1].track_name);
	  fgets (data.data_track[track - 1].track_name, 100, stdin);
	  data.data_track[track -
			  1].track_name[strlen (data.data_track[track - 1].
						track_name) - 1] = '\0';
	}
      if (cddb_write_disc_data (dcd->fd, data) < 0)
	{
	  printf ("Error: No CD in drive\n");
	  break;
	}
    }
   free(buff2);
return 0;
}
int
com_submit (DCD *dcd)
     
      
{
   struct cddb_host host;
   struct cddb_server *proxy;
   char *mail;
   mail=malloc(300);
  proxy = (struct cddb_server *) malloc (sizeof (struct cddb_server));
   
   getinput (mail, "Email Address: ");
           if(!cddb_http_submit(dcd->fd, host, proxy, mail))
            fprintf(stderr, "Submission error: %s\n", cddb_message);
          else
   puts("Submitted!");
 return 0;
}
COMMAND *
find_command (name)
     char *name;
{
  register int i;

  for (i = 0; commands[i].name; i++)
    if (strcasecmp (name, commands[i].name) == 0)
      return (&commands[i]);

  return ((COMMAND *) NULL);
}

int
fmistake (char *string, char *test, int l, int type)
{
  COMMAND *list;
  COMMAND *list2;
  int x;
  char string2[30];
  char buf[30];

#ifdef MODSUPPORT
  char *list3[] =
   { "list", "play", "next", "prev", "stop", "pause", "resume", "eject",
      "close", "status", "clear", "reset","vol", "chdisc", "info", "rew",
      "ff", "dcache", "edit", "submit", "help", "quit", "access", "save",
      "type", "random",
    "insmod", "rmmod", "lsmod", "rcvals", "version", "mode", "sframe", "rframe", "set"
  };

  char *list4[] =
    { "list", "play", "next", "prev", "stop", "pause", "resume", "eject",
      "close", "status", "clear", "reset","vol", "chdisc", "info", "rew",
      "ff", "dcache", "edit", "submit", "help", "quit", "access", "save",
      "type", "random",
    "insmod", "rmmod", "lsmod", "rcvals", "version", "mode", "sframe", "set",
     "rframe"
  };

#else
  char *list3[] =
    { "list", "play", "next", "prev", "stop", "pause", "resume", "eject",
      "close", "status", "clear", "reset", "vol", "chdisc", "info", "rew",
      "ff", "dcache", "edit", "submit", "help", "quit", "access", "save",
      "type", "random", "rcvals", "version", "mode", "sframe", "rframe", "set"
  };
  char *list4[] =
    { "list", "play", "next", "prev", "stop", "pause", "resume", "eject",
      "close", "status", "clear", "reset", "vol", "chdisc", "info", "rew",
      "ff", "dcache", "edit", "submit", "help", "quit", "access", "save",
      "type", "random", "rcvals", "version", "mode", "sframe", "rframe", "set"
  };


#endif 

  list = commands;
  list2 = commands;
  strcpy (string2, string);
  if (type == 0)
    {
      while (strlen (string) > l)
	{
	  string++;
	}
      for (x = 0; x < sizeof (list3) / sizeof (char *); x++)
	{
	  while (strlen (list3[x]) > l)
	    {
	      list3[x]++;
	    }
	  if (!strcmp (list3[x], string))
	    {
	      printf ("Correct \'%s\' to \'%s\' [yn]? ", string2, list4[x]);
	      fgets (buf, 512, stdin);
	      buf[strlen (buf) - 1] = '\0';
	      if (!strcasecmp (buf, "y"))
		{
		  strcpy (test, list4[x]);
		  return 1;
		}
	      else if (!strcasecmp (buf, "n"))
		{
		  return (0);
		}
	    }
	}
    }
  if (type == 1)
    {
      for (x = 0; commands[x].name; x++)
	{
	  if (!strncmp (list[x].name, string, l))
	    {
	      printf ("Correct \'%s\' to \'%s\' [yn]? ", string,
		      list[x].name);
	      fgets (buf, 512, stdin);
	      buf[strlen (buf) - 1] = '\0';
	      if (!strcasecmp (buf, "y"))
		{
		  strcpy (test, list[x].name);
		  return 1;
		}
	      else if (!strcasecmp (buf, "n"))
		{
		  return (0);
		}
	    }
	}
    }

  return (-2);
}

int
Derr (char *buf)
{
    if(strlen(buf) > 0)
     {
  printf ("Error: command not found: %s\n", buf);
  printf ("See: help for valid commands\n");
     }
  return 0;
}

char *
command_generator (text, state)
     char *text;
     int state;
{
  static int list_index, len;
  char *name;
  if (!state)
    {
      list_index = 0;
      len = strlen (text);
    }
  while ((name=commands[list_index].name))
    {
      list_index++;

      if (strncasecmp (name, text, len) == 0)
	return (dupstr (name));
    }
  return ((char *) NULL);
}
